

typedef struct {
  unsigned int chr;
  int w;
  int a, h;
  unsigned char *data;
} glyph_t;

int max(int a, int b) { return a>b? a:b; }

unsigned char *pad_bitmap(unsigned char *bmp, int w,int h, int top, int bot)
{
   unsigned char *R;
   int Y, X;
   R= calloc(1,w*(h+top+bot)*sizeof(unsigned char));
   for(Y=top;Y<top+h;Y++)
     for(X=0;X<w;X++)
       R[Y*w+X]= bmp[(Y-top)*w+X];
   return R;
}

glyph_t *render_glyphs(unsigned int *chr, int len,int *fontA, int *fontH)
{
  glyph_t *G;
  int i;
  int max_a, max_h,max_d;

  G= malloc(sizeof(*G)*len);
  max_a= max_d= max_h= 0;
  for(i=0;i<len;i++)
  {
    G[i].chr= chr[i];
    if (font_render(chr[i], &G[i].w, &G[i].h, &G[i].a, (void*) &G[i].data))
       exit(1);
    max_a= max(max_a, G[i].a);
    max_d= max(max_d, G[i].h - G[i].a);
  }

  max_h= max_a+max_d;
  for(i=0;i<len;i++)
  {
     int dD, dA;
     dD= max_d - (G[i].h-G[i].a);
     dA= max_a - G[i].a;
     if (dD || dA) 
        G[i].data= pad_bitmap(G[i].data, G[i].w, G[i].h, dA, dD);
        
     G[i].a= max_a;
     G[i].h= max_h;
  }
  
  *fontA= max_a;
  *fontH= max_h;
  return G;
}

void print_font_data(glyph_t *G, int N)
{
  int P,i,j,dL;
  P= 0;
  for(i=0;i<N;i++)
  {
    dL= G[i].w*G[i].h;
    for(j=0;j<dL;j++)
    {
       if (P%18==0) printf("\n");
       printf("0x%02x,", G[i].data[j]);
       P++;
    } 
  }
  printf("\n");
}

void print_font_map(glyph_t *G, int N)
{
  int P,i,T;
  P= 0; T= 0;
  for(i=0;i<N;i++)
  {
    if (P%4==0) printf("\n");
    printf("{%d,%d}, ", T, G[i].w);
    T+= G[i].w*G[i].h;
    P++;
  }
  printf("\n");
}

